<div class="wrap cost-calculator-settings-section">
	<h2><?php _e("Payments Config", "cost-calculator"); ?></h2>
</div>
<?php
if(!empty($message))
{
?>
<div class="<?php echo ($message!="" ? "updated" : ""); ?> settings-error"> 
	<p>
		<?php echo $message; ?>
	</p>
</div>
<?php
}
if(!empty($error))
{
	?>
	<div class="<?php echo ($error!="" ? "error" : ""); ?> settings-error"> 
		<p>
			<?php echo $error; ?>
		</p>
	</div>
	<?php
}
//get google fonts
$fontsArray = cc_get_google_fonts();
?>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post" class="cost-calculator-config-form">
	<div class="cost-calculator-form-table-container">
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row">
						<label for="stripe_payments_enabled">
							<?php esc_html_e("Stripe payments enabled", 'cost-calculator'); ?>
						</label>
					</th>
					<td>
						<select id="stripe_payments_enabled" name="stripe_payments_enabled">
							<option value="0"<?php echo (empty($cost_calculator_payments_options["stripe_payments_enabled"]) || !(int)$cost_calculator_payments_options["stripe_payments_enabled"] ? " selected='selected'" : ""); ?>><?php esc_html_e("no", 'cost-calculator'); ?></option>
							<option value="1"<?php echo ((int)$cost_calculator_payments_options["stripe_payments_enabled"]==1 ? " selected='selected'" : ""); ?>><?php esc_html_e("yes", 'cost-calculator'); ?></option>
						</select>
					</td>
				</tr>
				<tr valign="top" class="stripe-payments-enabled-depends<?php echo (!(int)$cost_calculator_payments_options["stripe_payments_enabled"] ? ' cost-calculator-hidden' : ''); ?>">
					<th scope="row">
						<label for="stripe_api_secret_key">
							<?php esc_html_e("Stripe API secret key", 'cost-calculator'); ?>
						</label>
					</th>
					<td>
						<input type="text" class="regular-text input-full-width" value="<?php echo esc_attr($cost_calculator_payments_options["stripe_api_secret_key"]); ?>" id="stripe_api_secret_key" name="stripe_api_secret_key">
						<label class="small_label"><?php echo sprintf(__("Get Stripe API key <a href='%s' title='%s' target='_blank'>here</a>", 'cost-calculator'), esc_url("https://dashboard.stripe.com/apikeys"), esc_attr("Stripe API key", 'cost-calculator')); ?></label>
					</td>
				</tr>
				<tr valign="top" class="stripe-payments-enabled-depends<?php echo (!(int)$cost_calculator_payments_options["stripe_payments_enabled"] ? ' cost-calculator-hidden' : ''); ?>">
					<th scope="row">
						<label for="stripe_api_secret_key">
							<?php esc_html_e("Stripe payment methods", 'cost-calculator'); ?>
						</label>
					</th>
					<td>
						<a href="https://dashboard.stripe.com/settings/payment_methods" title="<?php esc_attr_e("Manage payment methods", 'cost-calculator'); ?>" target="_blank"><?php esc_html_e("Manage payment methods", 'cost-calculator'); ?></a>
					</td>
				</tr>
				<tr valign="top" class="stripe-payments-enabled-depends<?php echo (!(int)$cost_calculator_payments_options["stripe_payments_enabled"] ? ' cost-calculator-hidden' : ''); ?>">
					<th scope="row">
						<label for="send_payment_email">
							<?php _e("Send payment confirmation email to admin", "cost-calculator"); ?>
						</label>
					</th>
					<td>
						<select id="send_payment_email" name="send_payment_email">
							<option value="1"<?php echo ((int)$cost_calculator_payments_options["send_payment_email"] ? " selected='selected'" : ""); ?>><?php _e("yes", 'cost-calculator'); ?></option>
							<option value="0"<?php echo (!(int)$cost_calculator_payments_options["send_payment_email"] ? " selected='selected'" : ""); ?>><?php _e("no", 'cost-calculator'); ?></option>
						</select>
					</td>
				</tr>
				<tr valign="top" class="stripe-payments-enabled-depends<?php echo (!(int)$cost_calculator_payments_options["stripe_payments_enabled"] ? ' cost-calculator-hidden' : ''); ?>">
					<th scope="row">
						<label for="send_payment_email_client">
							<?php _e("Send payment confirmation email to client", "cost-calculator"); ?>
						</label>
					</th>
					<td>
						<select id="send_payment_email_client" name="send_payment_email_client">
							<option value="1"<?php echo ((int)$cost_calculator_payments_options["send_payment_email_client"] ? " selected='selected'" : ""); ?>><?php _e("yes", 'cost-calculator'); ?></option>
							<option value="0"<?php echo (!(int)$cost_calculator_payments_options["send_payment_email_client"] ? " selected='selected'" : ""); ?>><?php _e("no", 'cost-calculator'); ?></option>
						</select>
					</td>
				</tr>
				<tr valign="top" class="stripe-payments-enabled-depends<?php echo (!(int)$cost_calculator_payments_options["stripe_payments_enabled"] ? ' cost-calculator-hidden' : ''); ?>">
					<th scope="row">
						<label for="payment_success_page">
							<?php _e("Payment success page", "cost-calculator"); ?>
						</label>
					</th>
					<td>
						<select id="payment_success_page" name="payment_success_page">
							<?php
							foreach($cost_calculator_pages_array as $key=>$value)
							{
								?>
								<option value="<?php echo esc_attr($value); ?>"<?php echo (isset($cost_calculator_payments_options["payment_success_page"]) && (int)$cost_calculator_payments_options["payment_success_page"]==(int)$value ? " selected='selected'" : ""); ?>><?php echo esc_html($key); ?></option>
								<?php
							}
							?>
						</select>
					</td>
				</tr>
				<tr valign="top" class="stripe-payments-enabled-depends<?php echo (!(int)$cost_calculator_payments_options["stripe_payments_enabled"] ? ' cost-calculator-hidden' : ''); ?>">
					<th scope="row">
						<label for="payment_cancel_page">
							<?php _e("Payment cancel page", "cost-calculator"); ?>
						</label>
					</th>
					<td>
						<select id="payment_cancel_page" name="payment_cancel_page">
							<?php
							foreach($cost_calculator_pages_array as $key=>$value)
							{
								?>
								<option value="<?php echo esc_attr($value); ?>"<?php echo (isset($cost_calculator_payments_options["payment_cancel_page"]) && (int)$cost_calculator_payments_options["payment_cancel_page"]==(int)$value ? " selected='selected'" : ""); ?>><?php echo esc_html($key); ?></option>
								<?php
							}
							?>
						</select>
					</td>
				</tr>
				<tr valign="top" class="stripe-payments-enabled-depends<?php echo (!(int)$cost_calculator_payments_options["stripe_payments_enabled"] ? ' cost-calculator-hidden' : ''); ?>">
					<th scope="row">
						<label for="subscription_cancel_page">
							<?php _e("Subscription cancel page", "cost-calculator"); ?>
						</label>
					</th>
					<td>
						<select id="subscription_cancel_page" name="subscription_cancel_page">
							<?php
							foreach($cost_calculator_pages_array as $key=>$value)
							{
								?>
								<option value="<?php echo esc_attr($value); ?>"<?php echo (isset($cost_calculator_payments_options["subscription_cancel_page"]) && (int)$cost_calculator_payments_options["subscription_cancel_page"]==(int)$value ? " selected='selected'" : ""); ?>><?php echo esc_html($key); ?></option>
								<?php
							}
							?>
						</select>
					</td>
				</tr>
				<tr valign="top" class="no-border">
					<th colspan="2">
						<input type="submit" value="<?php esc_attr_e("Save Options", 'cost-calculator'); ?>" class="button-primary" name="submit">
						<input type="hidden" name="action" value="save">
					</th>
				</tr>
			</tbody>
		</table>
	</div>
</form>